-- HexFlow Launcher  version 0.1 by VitaHEX
-- https://www.patreon.com/vitahex

local working_dir = "ux0:/app"
local appversion = "0.1"
function System.currentDirectory(dir)
	if dir == nil then
		return working_dir
	else
		working_dir = dir
	end
end

--Network.init()
Sound.init()
local click = Sound.open("app0:/DATA/click2.wav")
local imgCoverTmp = Graphics.loadImage("app0:/DATA/noimg.png")
local btnX = Graphics.loadImage("app0:/DATA/x.png")
local btnT = Graphics.loadImage("app0:/DATA/t.png")
local btnS = Graphics.loadImage("app0:/DATA/s.png")
local btnO = Graphics.loadImage("app0:/DATA/o.png")
local imgWifi = Graphics.loadImage("app0:/DATA/wifi.png")
local imgBattery = Graphics.loadImage("app0:/DATA/bat.png")
local imgBack = Graphics.loadImage("app0:/DATA/back_01.jpg")


local cur_dir = "ux0:/data/HexFlow/"
local covers_psv = "ux0:/data/HexFlow/COVERS/PSVITA/"

-- Create directories
System.createDirectory("ux0:/data/HexFlow/")
System.createDirectory("ux0:/data/HexFlow/COVERS/")
System.createDirectory(covers_psv)

-- load textures
local imgBox = Graphics.loadImage("app0:/DATA/vita_cover.png")

-- Load models
local modBox = Render.loadObject("app0:/DATA/box.obj", imgBox)
local modCover = Render.loadObject("app0:/DATA/cover.obj", imgCoverTmp)
local modBackground = Render.loadObject("app0:/DATA/planebg.obj", imgBack)

-- Custom Background
local imgCustomBack
if System.doesFileExist("ux0:/data/HexFlow/Background.png") then
	imgCustomBack = Graphics.loadImage("ux0:/data/HexFlow/Background.png")
	Graphics.setImageFilters(imgCustomBack, FILTER_LINEAR, FILTER_LINEAR)
	Render.useTexture(modBackground, imgCustomBack)
elseif System.doesFileExist("ux0:/data/HexFlow/Background.jpg") then
	imgCustomBack = Graphics.loadImage("ux0:/data/HexFlow/Background.jpg")
	Graphics.setImageFilters(imgCustomBack, FILTER_LINEAR, FILTER_LINEAR)
	Render.useTexture(modBackground, imgCustomBack)
end


local img_path = ""

local fnt = Font.load("app0:/DATA/font.ttf")
local menuX = 0
local showMenu = 0
local showCat = 0
local showView = 0

local info = System.extractSfo("app0:/sce_sys/param.sfo")
local app_version = info.version
local app_title = info.title
local app_category = info.category
local app_titleid = info.titleid

local master_index = 1
local p = 1
local oldpad = 0
local delayTouch = 8.0
local delayButton = 8.0

-- Init Colors
local black = Color.new(0,0,0)
local grey = Color.new(45,45,45) 
local white = Color.new(255,255,255)
local red = Color.new(255, 0, 0)
local blue = Color.new(2,72,158)
local bg = Color.new(153,217,234)

local targetX=0
local xstart = 0
local ystart = 0
local space = 1
local touchdown = 0
local startCovers = false
local inPreview = false

local prevX = 0
local prevZ = 0
local prevRot = 0


-- Speed related settings
local cpu_speed = 333
System.setBusSpeed(222)
System.setGpuSpeed(222)
System.setGpuXbarSpeed(166)
System.setCpuSpeed(cpu_speed)

function OneshotPrint(my_func)
	my_func()
	Screen.flip()
	my_func()
	Screen.flip()
	my_func()
end

function PrintCentered(font, x,y,text,color,size)
	Font.setPixelSizes(font, size)
	Font.print(font, x-((string.len(text)/2)*(size/3))-string.len(text),y,text,color)
end

function TableConcat(t1,t2)
    for i=1,#t2 do
        t1[#t1+1] = t2[i]
    end
    return t1
end

function FreeMemory()
	Graphics.freeImage(imgCoverTmp)
	Graphics.freeImage(btnX)
	Graphics.freeImage(btnT)
	Graphics.freeImage(btnS)
	Graphics.freeImage(btnO)
	Graphics.freeImage(imgWifi)
	Graphics.freeImage(imgBattery)
	Graphics.freeImage(imgBack)
	Graphics.freeImage(imgBox)
end

function listDirectory(dir)
	dir = System.listDirectory(dir)
	folders_table = {}
	files_table = {}
	
	for i,file in pairs(dir) do
		if file.directory then
			if showCat==1 then
			-- LIST GAMES
				if string.match(file.name, "PCS") and not string.match(file.name, "PCSI") then
					table.insert(folders_table,file)
				end
			else
			-- LIST ALL
				table.insert(folders_table,file)
			end
		end
		
		img_path = "ur0:/appmeta/" .. file.name .. "/icon0.png"
		
		-- get app name to match with custom cover file name
		info = System.extractSfo(working_dir .. "/" .. file.name .. "/sce_sys/param.sfo")
		app_title = info.title
		
		custom_path = covers_psv .. app_title .. ".png"
		custom_path_id = covers_psv .. file.name .. ".png"
		

		if pcall(loadImage, custom_path) then
			-- load custom cover from app name
			if System.doesFileExist(custom_path) then
			imgTmp = Graphics.loadImage(custom_path)
			file.icon=imgTmp
			table.insert(files_table, 4,file.icon)
			end
		elseif pcall(loadImage, custom_path_id) then
			-- load custom cover from app id
			if System.doesFileExist(custom_path_id) then
			imgTmp = Graphics.loadImage(custom_path_id)
			file.icon=imgTmp
			table.insert(files_table, 4,file.icon)
			end
		else
			if not pcall(loadImage, img_path) then 
				-- no icon use blank
				imgTmp = imgCoverTmp
				file.icon=imgTmp
				table.insert(files_table, 4,file.icon)
			else
				-- load app icon
				if System.doesFileExist(img_path) then
				imgTmp = Graphics.loadImage(img_path)
				file.icon=imgTmp
				table.insert(files_table, 4,file.icon)
				end
			end
		end

		
	end
	table.sort(files_table, function (a, b) return (a.name:lower() < b.name:lower() ) end)
	table.sort(folders_table, function (a, b) return (a.name:lower() < b.name:lower() ) end)
	return_table = TableConcat(folders_table,files_table)
		
	return return_table
end

function loadImage (img_path) 
	imgTmp = Graphics.loadImage(img_path) 
end

files_table = listDirectory(System.currentDirectory())
	
function GetInfoSelected () 
	info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
	app_title = info.title
	app_titleid = info.titleid
end



local function DrawCover(x, y, text, icon, sel)
	rot=0
	extraz=0
	extrax=0
	Graphics.setImageFilters(icon, FILTER_LINEAR, FILTER_LINEAR)
	Render.useTexture(modCover, icon) 
	if showView==1 then
	-- flat zoom out view
		space=1.6
		if x>0.5 then
			extraz=6
			extrax=1
		elseif x<-0.5 then
			extraz=6
			extrax=-1
		end
	else
	-- default view
		space=1
		if x>0.5 then
			rot=-1
			extraz=3
			extrax=1
		elseif x<-0.5 then
			rot=1
			extraz=3
			extrax=-1
		end
	end

	
	Render.drawModel(modCover,  x+extrax, y, -5-extraz, 0, math.deg(rot), 0)
	Render.drawModel(modBox,  x+extrax, y, -5-extraz, 0, math.deg(rot), 0)
end

-- Main loop
while true do
		
	-- Reading input
	pad = Controls.read()
	
	mx, my = Controls.readLeftAnalog()
	
	-- touch input
	x1,y1 = Controls.readTouch() 
	
	-- Initializing rendering
	Graphics.initBlend()
	Screen.clear(black) 

	if delayButton > 0 then
		delayButton = delayButton -0.1 
	else
		delayButton=0
	end

-- Graphics
	Render.drawModel(modBackground, 0, 0, -5, 0, 0, 0) -- Draw Background as model
	Graphics.fillRect(0, 960, 496, 544, blue)-- blue footer bottom
			
	if showMenu == 0 then
-- MAIN VIEW
	
	-- Footer
	Graphics.fillRect(0, 960, 424, 496, black)-- black footer bottom
    -- Header
        h,m,s = System.getTime()
        Font.setPixelSizes(fnt, 22)
        Font.print(fnt, 726, 34, string.format("%02d:%02d",h,m), white)-- Draw time
        life = System.getBatteryPercentage()
        Font.print(fnt, 830, 34, life .. "%", white)-- Draw battery
        Graphics.drawImage(888, 41, imgBattery)
        Graphics.fillRect(891, 891+(life/5.2), 45, 53, white)
	-- Footer buttons and icons
		Font.setPixelSizes(fnt, 22)
		Graphics.drawImage(850, 510, btnX)
		Font.print(fnt, 878, 506, "Launch", white)
		Graphics.drawImage(750, 510, btnT)
		Font.print(fnt, 778, 506, "Details", white)
		Graphics.drawImage(620, 510, btnS)
		Font.print(fnt, 648, 506, "Category", white)
		Graphics.drawImage(530, 510, btnO)
		Font.print(fnt, 558, 506, "View", white)
		
		Font.setPixelSizes(fnt, 24)
		if showCat==1 then
			Font.print(fnt, 32, 34, "GAMES", white)
		else
			Font.print(fnt, 32, 34, "ALL", white)
		
		end
        --if Network.isWifiEnabled() then
        --    Graphics.drawImage(800, 38, imgWifi) -- wifi icon
        --end
    
    	PrintCentered(fnt, 480, 427, app_title, white,28)-- Draw title
    	PrintCentered(fnt, 480, 460, p .. " of " .. #files_table, white, 22)-- Draw total items
    	
    		
    	-- Draw Covers
    	base_x = 0
    
        for l, file in pairs(files_table) do
            if (l >= master_index) then
                base_x = base_x + space
            end
			if base_x>base_x-8 and base_x<base_x+8 then
				DrawCover((targetX+l*space)-(#files_table*space+space),-0.6,file.name, file.icon, base_x)--draw visible covers only
			end
        end
    		
    	-- Smooth move items horizontally
    	if targetX<base_x then
    		targetX=targetX+(-(targetX-base_x)*0.1)
    	elseif targetX>base_x then
    		targetX=targetX-((targetX-base_x)*0.1)
    	else
    		targetX=base_x
    	end
    	
    	-- Instantly move to selection
    	if startCovers==false then
    		targetX=base_x
    		startCovers=true
    		GetInfoSelected ()
    	end
		
		prevX = 0
		prevZ = 0
		prevRot = 0
		inPreview = false
    elseif showMenu == 1 then
	
-- PREVIEW

	-- Footer buttons and icons
		Font.setPixelSizes(fnt, 22)
		Graphics.drawImage(850, 510, btnO)
		Font.print(fnt, 878, 506, "Close", white)
				
		Graphics.fillRect(24, 450, 24, 450, blue)-- blue bg
		
		if inPreview == false then
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
			app_titleid = info.titleid
			app_version = info.version
			
			icon_path = "ur0:/appmeta/" .. files_table[p].name .. "/icon0.png"
			
			if not pcall(loadImage, icon_path) then 
				iconTmp = imgCoverTmp --Graphics.loadImage("app0:/DATA/noimg.png")
			else
				iconTmp = Graphics.loadImage(icon_path)
			end
			
			inPreview = true
		end

		
		-- animate cover zoom in
		if prevX<1.4 then
			prevX=prevX+0.1
		end
		if prevZ<1 then
			prevZ=prevZ+0.06
		end
		if prevRot>-0.6 then
			prevRot=prevRot-0.04
		end

		Graphics.drawImage(50, 50, iconTmp)-- icon
		
		txtname = string.sub(app_title,1,32) .. "\n" .. string.sub(app_title,33)
		
		Font.setPixelSizes(fnt, 24)
        Font.print(fnt, 50, 190, txtname, white)-- app name
		Font.setPixelSizes(fnt, 22)
        Font.print(fnt, 50, 240, "App ID: " .. app_titleid .. "\nVersion: " .. app_version, white)-- Draw info

		Graphics.setImageFilters(files_table[p].icon, FILTER_LINEAR, FILTER_LINEAR)
		Render.useTexture(modCover, files_table[p].icon) 
		Render.drawModel(modCover,  prevX, -0.8, -5+prevZ, 0, math.deg(prevRot), 0)
		Render.drawModel(modBox,  prevX, -0.8, -5+prevZ, 0, math.deg(prevRot), 0)

    elseif showMenu == 2 then
	
-- SETTINGS
	-- Footer buttons and icons
		Font.setPixelSizes(fnt, 22)
		Graphics.drawImage(850, 510, btnO)
		Font.print(fnt, 878, 506, "Close", white)
				
		Graphics.fillRect(60, 900, 24, 472, grey)-- grey bg
		
		Font.setPixelSizes(fnt, 24)
        Font.print(fnt, 84, 42, "HexFlow Launcher - ver." .. appversion .. "\nby VitaHEX Games\nSupport this project on patreon.com/vitahex", white)-- Draw info
		Font.setPixelSizes(fnt, 22)
		Font.print(fnt, 84, 152, "Custom Covers\nPlace your custom covers in 'ux0:/data/HexFlow/COVERS/PSVITA/'\nCover images must be in png format and file name must match the App ID or the App Name."
		.. "\n\nCustom Background\nPlace your custom background image in 'ux0:/data/HexFlow/'\nBackground image must be named 'Background.jpg' or 'Background.png' (720p max)"
		.. "\n\nCredits\nProgramming/UI\nSakis RG\n\nDeveloped with Lua Player Plus by\nRinnegatamante", white)-- Draw info

	end
	
	-- Terminating rendering phase
	Graphics.termBlend()
	
--Controls Start
	if showMenu == 0 then
	--Navigation Left Analog
	if mx < 64 then
		if delayButton<0.5 then
		delayButton=1
		Sound.play(click, NO_LOOP)
			p = p - 1
			
			if p>0 then
				GetInfoSelected ()
			end	
			
			if (p<=master_index) then 
				master_index = p
			end
		end
	elseif mx > 180 then
		if delayButton<0.5 then
		delayButton=1
		Sound.play(click, NO_LOOP)
			p = p + 1
			
			if p<=#files_table then
				GetInfoSelected ()
			end
			
			if (p >= master_index) then 
				master_index = p
			end
		end
	end
	
    -- Navigation Buttons
    if (Controls.check(pad,SCE_CTRL_CROSS) and not Controls.check(oldpad,SCE_CTRL_CROSS)) then
		FreeMemory()
		System.launchApp(files_table[p].name)
		System.exit()
	elseif (Controls.check(pad,SCE_CTRL_TRIANGLE) and not Controls.check(oldpad,SCE_CTRL_TRIANGLE)) then
		if showMenu==0 then
			showMenu = 1
		end
	elseif (Controls.check(pad,SCE_CTRL_START) and not Controls.check(oldpad,SCE_CTRL_START)) then
		if showMenu==0 then
			showMenu = 2
		end
	elseif (Controls.check(pad,SCE_CTRL_SQUARE) and not Controls.check(oldpad,SCE_CTRL_SQUARE)) then
		-- CATEGORY
		if showCat==0 then
			showCat=1
			files_table = listDirectory(System.currentDirectory())
		else
			showCat=0
			files_table = listDirectory(System.currentDirectory())
		end
		p = 1
		master_index = p
		startCovers=false
		GetInfoSelected ()
	elseif (Controls.check(pad,SCE_CTRL_CIRCLE) and not Controls.check(oldpad,SCE_CTRL_CIRCLE)) then
		-- VIEW
		if showView==0 then
			showView=1
		else
			showView=0
		end
		startCovers=false
	elseif (Controls.check(pad,SCE_CTRL_LEFT)) and not (Controls.check(oldpad,SCE_CTRL_LEFT)) then
		Sound.play(click, NO_LOOP)
		p = p - 1
			
		if p>0 then
			GetInfoSelected ()
		end	
			
		if (p<=master_index) then 
			master_index = p
		end
	elseif (Controls.check(pad,SCE_CTRL_RIGHT)) and not (Controls.check(oldpad,SCE_CTRL_RIGHT)) then
		Sound.play(click, NO_LOOP)
		p = p + 1
			
		if p<=#files_table then
			GetInfoSelected ()
		end
			
		if (p >= master_index) then 
			master_index = p
		end
		elseif (Controls.check(pad,SCE_CTRL_LTRIGGER)) and not (Controls.check(oldpad,SCE_CTRL_LTRIGGER)) then
		Sound.play(click, NO_LOOP)
		p = p - 5
			
		if p>0 then
			GetInfoSelected ()
		end	
			
		if (p<=master_index) then 
			master_index = p
		end
	elseif (Controls.check(pad,SCE_CTRL_RTRIGGER)) and not (Controls.check(oldpad,SCE_CTRL_RTRIGGER)) then
		Sound.play(click, NO_LOOP)
		p = p + 5
			
		if p<=#files_table then
			GetInfoSelected ()
		end
			
		if (p >= master_index) then 
			master_index = p
		end
	end
		
    -- Touch Input
	if x1 ~= nil then
		if touchdown==0 and delayTouch<0.5 then
			touchdown=1
			xstart=x1
			delayTouch=5
		end
		if touchdown>0 and delayTouch>0.5 then 
			if x1>xstart+60 then
				touchdown=2
				xstart=x1
				p = p-1
				if (p<=master_index) then 
					master_index = p
				end
				GetInfoSelected ()
			elseif x1<xstart-60 then
				touchdown=2
				xstart=x1
				p = p+1
				if (p >= master_index) then 
					master_index = p
				end
				GetInfoSelected ()
			end
		end
	end
	elseif showMenu == 1 or showMenu == 2 then
	    if (Controls.check(pad,SCE_CTRL_CIRCLE) and not Controls.check(oldpad,SCE_CTRL_CIRCLE)) then
		showMenu = 0
		end
	end	
		
	if delayTouch > 0 then
		delayTouch = delayTouch -0.1 
	else
		delayTouch=0
		touchdown=0
	end
	-- End Touch
	
-- End Controls
	
	-- Check for out of bounds in menu
		if p < 1 then
			p = #files_table
			if p >= 1 then 
				master_index = p -- 0
			end
			startCovers=false
			GetInfoSelected ()
		elseif p > #files_table then
			p = 1
			master_index = p
			startCovers=false
			GetInfoSelected ()
		end

	-- Refreshing screen and oldpad
	Screen.waitVblankStart()
	Screen.flip()
	oldpad = pad
end
